/**
***     Copyright (C) 2003 - 2008 SophiaCradle, Inc.
***     All rights reserved.
**/

#ifndef __FILESYSTEM_HPP
#define __FILESYSTEM_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(Filesystem)
class Filesystem : public SFCApplication {
    private:
        // 񓯊ǂݍݗp̃o
        SFXFile _file;
        SFXAnsiStringStreamReader _reader;
        SFXAnsiString _string;

    public:
        static  SFCInvokerPtr   Factory                     (Void);
    private:
                                Filesystem                  (Void);
        virtual                 ~Filesystem                 (Void);
        virtual Bool            HandleEvent                 (SFXEventConstRef);
        virtual Bool            HandleRender                (SFXEventConstRef);
                Bool            OnAppStart                  (Void);
                Bool            OnAppStop                   (Void);
                Bool            OnAppResume                 (Void);
                Bool            OnAppSuspend                (Void);
                Bool            OnAppKey                    (UInt16);
                Void            CreateRemoveDirectory       (Void);
                Void            CreateDirectoryRecursive    (Void);
                Void            GetInfoRecursive            (SFXPathConstRef);
                Void            RmDirRecursive              (SFXPathConstRef);
                Void            CreateCloseFile             (Void);
                Void            OpenCloseFile               (Void);
                Void            GetInfo                     (Void);
                Void            FileRead                    (Void);
                Void            FileReadAsync               (Void);
                Void            ReadCallback                (Void);
                Void            FileWrite                   (Void);
                Void            ClearScreen                 (Void);
                Void            Done                        (Void);
                XALLBACK_DECLARE_SFXSTREAMREADER(OnReadCallback)
};

#endif//__FILESYSTEM_HPP
